/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tEtSample_template.c => src/tEtSample.c
 * Τ褦̾, եѹƤ齤ޤ
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delay_time );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_task_id );
 *   ER             rotateReadyQueue( PRI task_priority );
 *   ER             getTime( SYSTIM* p_system_time );
 *   ER             getMicroTime( SYSUTM* p_system_micro_time );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interrupt_priority );
 *   ER             getInterruptPriorityMask( PRI* p_interrupt_priority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * require port : signature: siKernel context: non-task
 *   ER             ciKernel_getTaskId( ID* p_task_id );
 *   ER             ciKernel_rotateReadyQueue( PRI task_priority );
 *   ER             ciKernel_getMicroTime( SYSUTM* p_system_micro_time );
 *   ER             ciKernel_lockCpu( );
 *   ER             ciKernel_unlockCpu( );
 *   ER             ciKernel_exitKernel( );
 *   bool_t         ciKernel_senseContext( );
 *   bool_t         ciKernel_senseLock( );
 *   bool_t         ciKernel_senseDispatch( );
 *   bool_t         ciKernel_senseDispatchPendingState( );
 *   bool_t         ciKernel_senseKernel( );
 *   bool_t         ciKernel_senseDispatchPendingStateCPU( const void* p_exception_infomation );
 *   bool_t         ciKernel_senseTaskExceptionPendingStateCPU( const void* p_exception_infomation );
 * call port : cTask  signature: sTask context: task
 *   ER             cTask_activate( subscript );
 *   ER_UINT        cTask_cancelActivate( subscript );
 *   ER             cTask_terminate( subscript );
 *   ER             cTask_changePriority( subscript, PRI priority );
 *   ER             cTask_getPriority( subscript, PRI* p_priority );
 *   ER             cTask_refer( subscript, T_RTSK* pk_task_status );
 *   ER             cTask_wakeup( subscript );
 *   ER_UINT        cTask_cancelWakeup( subscript );
 *   ER             cTask_releaseWait( subscript );
 *   ER             cTask_suspend( subscript );
 *   ER             cTask_resume( subscript );
 *   ER             cTask_raiseException( subscript, TEXPTN pattern );
 * call port : cCyclic  signature: sCyclic context: task
 *   ER             cCyclic_start( subscript );
 *   ER             cCyclic_stop( subscript );
 *   ER             cCyclic_refer( subscript, T_RCYC* pk_cyclic_handler_status );
 * call port : cSerialPort  signature: sSerialPort context: task
 *   ER             cSerialPort_open( );
 *   ER             cSerialPort_close( );
 *   ER_UINT        cSerialPort_read( char_t* buf, uint_t len );
 *   ER_UINT        cSerialPort_write( const char_t* buf, uint_t len );
 *   ER             cSerialPort_control( uint_t ioctl );
 *   ER             cSerialPort_refer( T_SERIAL_RPOR* pk_rpor );
 * call port : cSysLog  signature: sSysLog context: task
 *   ER             cSysLog_write( uint_t prio, const SYSLOG* p_syslog );
 *   ER_UINT        cSysLog_read( SYSLOG* p_syslog );
 *   ER             cSysLog_mask( uint_t logmask, uint_t lowmask );
 *   ER             cSysLog_refer( T_SYSLOG_RLOG* pk_rlog );
 *
 * #[</PREAMBLE>]# */

#include "tETSample_tecsgen.h"

#include "tETsample.h"
#include "kernel_cfg.h"
#include "ecrobot_interface.h"
#include "ecrobot_base.h"

#include "balancer.h" /* NXTway-GS C API header file */
#include "nxt_config.h"

#include "kernel_impl.h"
#include <t_syslog.h>

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 桼 */
/*============================================================================
 * MACRO DEFINITIONS
 *===========================================================================*/
typedef enum{
	INIT_MODE, 	 /* system initialize mode */
	CAL_MODE,  	 /* gyro sensor offset calibration mode */
	CONTROL_MODE /* balance and RC control mode */
} MODE_ENUM;

#define BT_RCV_BUF_SIZE (32) /* 32bytes fixed for NXT GamePad */
#define	 MIN_DISTANCE  	 (25) /* minimum distance in cm for obstacle avoidance */

/*============================================================================
 * DATA DEFINITIONS
 *===========================================================================*/
MODE_ENUM nxtway_gs_mode = INIT_MODE; /* NXTway-GS mode */
volatile uint8_t obstacle_flag = 0;      /* 1(obstacle detected)/0(no obstacle) */
volatile int8_t cmd_forward, cmd_turn;

/*============================================================================
 * FUNCTIONS
 *===========================================================================*/
/*============================================================================
 * Embedded Coder Robot hook functions
 *===========================================================================*/
//*****************************************************************************
// FUNCTION		: ecrobot_device_initialize
// ARGUMENT		: none
// RETURN		: none
// DESCRIPTION 	: ECRobot device init hook function
//*****************************************************************************
void
ecrobot_device_initialize(void)
{
	ecrobot_set_light_sensor_active(PORT_LIGHT);
	ecrobot_init_bt_slave(BT_PASS_KEY);
}

//*****************************************************************************
// FUNCTION		: ecrobot_device_terminate
// ARGUMENT		: none
// RETURN		: none
// DESCRIPTION 	: ECRobot device term hook function
//*****************************************************************************
void
ecrobot_device_terminate(void)
{
	nxt_motor_set_speed(PORT_MOTOR_L, 0, 1);
	nxt_motor_set_speed(PORT_MOTOR_R, 0, 1);
	ecrobot_set_light_sensor_inactive(PORT_LIGHT);
	ecrobot_term_bt_connection();
}

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eDriverTask
 * entry port: eDriverTask
 * signature:  sTaskBody
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eDriverTask_main
 * name:         eDriverTask_main
 * global_name:  tEtSample_eDriverTask_main
 * oneway:       
 * #[/ENTRY_FUNC>]# */
void
eDriverTask_main()
{
	static uint32_t	gyro_offset;    /* gyro sensor offset value */
	static uint32_t avg_cnt;		    /* average count to calc gyro offset */
	static uint32_t	cal_start_time;	/* calibration start time */
	static uint32_t	cal_measure_time;	/* calibration start time */
	static uint8_t	bt_receive_buf[BT_RCV_BUF_SIZE]; /* Bluetooth receive buffer(32bytes) */
	int32_t i;
	int8_t	pwm_l, pwm_r;
	
	switch(nxtway_gs_mode){
		case(INIT_MODE):
			gyro_offset = 0;
			avg_cnt = 0;
			for (i = 0; i < BT_RCV_BUF_SIZE; i++){
				bt_receive_buf[i] = 0;
			}
			balance_init(); /* NXTway-GS C API initialize function */
			nxt_motor_set_count(PORT_MOTOR_L, 0); /* reset left motor count */
			nxt_motor_set_count(PORT_MOTOR_R, 0); /* reset right motor count */
			get_tim(&cal_start_time);
			//cal_start_time = ecrobot_get_systick_ms();
			nxtway_gs_mode = CAL_MODE;
			break;
						
		case(CAL_MODE):
			gyro_offset += (uint32_t)ecrobot_get_gyro_sensor(PORT_GYRO);
			avg_cnt++;
		    get_tim(&cal_measure_time);
			if ((cal_measure_time - cal_start_time) >= 1000U) { 
				/* 1000msec later, start balancing */
				gyro_offset /= avg_cnt;
				ecrobot_sound_tone(440U, 500U, 30U); /* beep a tone */
				nxtway_gs_mode = CONTROL_MODE;
			}
			break;
						
		case(CONTROL_MODE):
			(void)ecrobot_read_bt_packet(bt_receive_buf, BT_RCV_BUF_SIZE);
			/* 
			 * R/C command from NXT GamePad
			 * buf[0]: -100(forward max.) to 100(backward max.)
			 * buf[1]: -100(turn left max.) to 100(turn right max.)
			 */
			cmd_forward = -(int8_t)bt_receive_buf[0]; /* reverse the direction */
			cmd_turn = (int8_t)bt_receive_buf[1];
			if (obstacle_flag == 1){
				/* make NXTway-GS move backward to avoid obstacle */
				cmd_forward = -100;
				cmd_turn = 0;
			}

			/* NXTway-GS C API balance control function (has to be invoked in 4msec period) */
			balance_control(
				(float32_t)cmd_forward,
				(float32_t)cmd_turn,
				(float32_t)ecrobot_get_gyro_sensor(PORT_GYRO),
				(float32_t)gyro_offset,
				(float32_t)nxt_motor_get_count(PORT_MOTOR_L),
				(float32_t)nxt_motor_get_count(PORT_MOTOR_R),
				(float32_t)ecrobot_get_battery_voltage(),
				&pwm_l,
				&pwm_r);
			nxt_motor_set_speed(PORT_MOTOR_L, pwm_l, 1);
			nxt_motor_set_speed(PORT_MOTOR_R, pwm_r, 1);

			//ecrobot_bt_data_logger(cmd_forward, cmd_turn); /* Bluetooth data logger */
			break;
			
		default:
			/* unexpected mode */
			nxt_motor_set_speed(PORT_MOTOR_L, 0, 1);
			nxt_motor_set_speed(PORT_MOTOR_R, 0, 1);
			break;
	}
}

/* #[<ENTRY_PORT>]# eDistanceTask
 * entry port: eDistanceTask
 * signature:  sTaskBody
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eDistanceTask_main
 * name:         eDistanceTask_main
 * global_name:  tEtSample_eDistanceTask_main
 * oneway:       
 * #[/ENTRY_FUNC>]# */
void
eDistanceTask_main()
{
#if 0
	obstacle_flag = 0; /* no obstacles */
	if ((nxtway_gs_mode == CONTROL_MODE) && 
      (ecrobot_get_sonar_sensor(PORT_SONAR) <= MIN_DISTANCE)){
		obstacle_flag = 1; /* obstacle detected */
	}
#endif
}

/* #[<ENTRY_PORT>]# eDisplayTask
 * entry port: eDisplayTask
 * signature:  sTaskBody
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eDisplayTask_main
 * name:         eDisplayTask_main
 * global_name:  tEtSample_eDisplayTask_main
 * oneway:       
 * #[/ENTRY_FUNC>]# */
void
eDisplayTask_main()
{
	while(1){
		ecrobot_status_monitor("NXTway-GS ASP"); /* LCD display */
		delay(1000);
	}
}

/* #[<ENTRY_PORT>]# eUserProgram
 * entry port: eUserProgram
 * signature:  sUserProgram
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eUserProgram_start_task_cyc
 * name:         eUserProgram_start_task_cyc
 * global_name:  tEtSample_eUserProgram_start_task_cyc
 * oneway:       
 * #[/ENTRY_FUNC>]# */
void
eUserProgram_startCyclicTask()
{
	/* εư */
	cCyclicDriver_start();
	cCyclicDistance_start();
}
