/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tBalancer_template.c => src/tBalancer.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * turnMax          int16_t          ATTR_turnMax    
 * turnMin          int16_t          ATTR_turnMin    
 * gyroOffset       uint16_t         VAR_gyroOffset  
 *
 * ƤӸؿ #_TCPF_#
 * call port : cGyroSensor  signature: sSensor context: task
 *   void           cGyroSensor_getValue( uint16_t* value );
 * call port : cBatteryChecker  signature: sSensor context: task
 *   void           cBatteryChecker_getValue( uint16_t* value );
 *
 * #[</PREAMBLE>]# */

#include "tBalancer_tecsgen.h"
#include "ecrobot_interface.h"
#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBalancer
 * entry port: eBalancer
 * signature:  sBalancer
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBalancer_initialize
 * name:         eBalancer_initialize
 * global_name:  tBalancer_eBalancer_initialize
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancer_initialize(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	
	balance_init();
}

/* #[<ENTRY_FUNC>]# eBalancer_setGyroOffset
 * name:         eBalancer_setGyroOffset
 * global_name:  tBalancer_eBalancer_setGyroOffset
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancer_setGyroOffset(CELLIDX idx, uint16_t gyroOffset)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	
	VAR_gyroOffset = gyroOffset;
}

/* #[<ENTRY_FUNC>]# eBalancer_calculationPWM
 * name:         eBalancer_calculationPWM
 * global_name:  tBalancer_eBalancer_calculationPWM
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBalancer_calculationPWM(CELLIDX idx, int16_t forward, int16_t turn, int32_t leftRevolution, int32_t rightRevolution, int8_t* pwm_l, int8_t* pwm_r)
{
	CELLCB	*p_cellcb;
	uint16_t gyro, battery;
	
	static int16_t counter = 0;
	
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	cGyroSensor_getValue(&gyro); // 㥤󥵤ͤ
	cBatteryChecker_getValue(&battery); // Хåƥͤ

	/*
	 *  Ωѥѥ᡼η׻
	 */
	balance_control(
					(float32_t)forward,
					(float32_t)turn,
					(float32_t)gyro,
					(float32_t)VAR_gyroOffset,
					(float32_t)leftRevolution,
					(float32_t)rightRevolution,
					(float32_t)battery,
					pwm_l,
					pwm_r);
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
