/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id:
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSIOPortMindstormsNXT_template.c => src/tSIOPortMindstormsNXT.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * uartBase         void*            ATTR_uartBase   
 * sendBufferSize   uint32_t         ATTR_sendBufferSize
 * sendBufferPointerInitialize char_t           ATTR_sendBufferPointerInitialize
 * sendBufferCountInitialize uint32_t         ATTR_sendBufferCountInitialize
 * receiveBufferSize uint32_t         ATTR_receiveBufferSize
 * openFlag         bool_t           VAR_openFlag    
 * sendBuffer1      char_t*          VAR_sendBuffer1 
 * sendBuffer2      char_t*          VAR_sendBuffer2 
 * sendBufferPointer char_t*          VAR_sendBufferPointer
 * sendBufferCount  uint_t           VAR_sendBufferCount
 * UsedTargetbuffer bool_t           VAR_UsedTargetbuffer
 * UsedKernelbuffer bool_t           VAR_UsedKernelbuffer
 * receiveBuffer1   char_t*          VAR_receiveBuffer1
 * receiveBuffer2   char_t*          VAR_receiveBuffer2
 * receiveBufferPointer char_t*          VAR_receiveBufferPointer
 * receiveBufferCount uint32_t         VAR_receiveBufferCount
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : ciSIOCBR  signature: siSIOCBR context: task
 *   void           ciSIOCBR_readySend( );
 *   void           ciSIOCBR_readyReceive( );
 * call port : cBluetooth  signature: sBluetooth context: task
 *   void           cBluetooth_open( );
 *   bool_t         cBluetooth_getLocalAddress( uint8_t* address );
 *   bool_t         cBluetooth_getDeviceName( uint8_t* name );
 *   bool_t         cBluetooth_setDeviceName( const uint8_t* name );
 *   bool_t         cBluetooth_setFactorySetting( );
 *   uint8_t        cBluetooth_getStatus( );
 *   int32_t        cBluetooth_initializeMaster( const uint8_t* address, const uint8_t* pin );
 *   int32_t        cBluetooth_initializeSlave( const uint8_t* pin );
 *   void           cBluetooth_terminateConnection( );
 *   uint32_t       cBluetooth_sendPacket( const uint8_t* buffer, uint32_t length );
 *   uint32_t       cBluetooth_readPacket( uint8_t* buffer, uint32_t length );
 *
 * #[</PREAMBLE>]# */
/*
 *		ꥢI/OǥХSIO˥ɥ饤СmindstormsNXTѡ
 */

#include "tSIOPortMindstormsNXT_tecsgen.h"
#include "target_serial.h"
#include "at91sam7s.h"
#include <t_stddef.h>
#include <t_syslog.h>

#include "ecrobot_interface.h"
#include "ecrobot_bluetooth.h"
#include "nxt_config.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/*
 *  Хåեơѥ桼ƥƥ
 */
inline void
rot_target_receive_buf(CELLCB *p_cellcb)
{
	if(VAR_receiveBufferPointer == VAR_receiveBuffer1){
		VAR_receiveBufferPointer = VAR_receiveBuffer2;
	} else {
		VAR_receiveBufferPointer = VAR_receiveBuffer1;
	}
}

inline void
rot_target_send_buf(CELLCB *p_cellcb)
{
	if(VAR_sendBufferPointer == VAR_sendBuffer1) {
		VAR_sendBufferPointer = VAR_sendBuffer2;
	} else {
		VAR_sendBufferPointer = VAR_sendBuffer1;
	}
}

/*
 * ʸ?
 * DMAžˤꡤ1ܤΥХåեFULLˤʤäɤ֤
 */ 
Inline bool_t
uart_getready(CELLCB *p_cellcb)
{
	return (sil_rew_mem((void*)(ATTR_uartBase+TOFF_PDC_RNCR)) == 0);
}

/*
 *  DMAž椫?
 *  DMAžʤfalseǤʤtrue֤
 */
Inline bool_t
uart_puts_ready(CELLCB *p_cellcb)
{
	return (sil_rew_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR)) == 0);
}

/*
 *  ʸμФ
 *  DMAμХåեꤹ
 */
Inline uint8_t
uart_getchar(CELLCB *p_cellcb)
{
	uint8_t c;
	
	if(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR)) == 0){
		/* ʸФ */
		c = VAR_receiveBufferPointer[0];

		/*
		 *  DMA˿Хåեꤹ
		 *  ꤹХåեϡǶʸХåեǤꡤ
		 *  1ԾǻѤƤХåեǤ
		 */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNPR), VAR_receiveBufferPointer);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), ATTR_receiveBufferSize);

		/* ХåեΥơ */
		rot_target_receive_buf(p_cellcb);
		
	}
	
	return c;
}

/* 
 *  DMAž
 */
Inline void
uart_puts(CELLCB *p_cellcb)
{
	/*
	 * 	bluetoothȤϡǡƬ˥ɲäɬפ
     *  ǡΰ2byteǡȥ륨ǥǤ
	 */
/*     VAR_sendBufferCount -= 2; // ǡ2byteʤ
 * 	VAR_sendBufferPointer[0] = (uint8_t)(VAR_sendBufferCount & 0xFF); // 
 * 	VAR_sendBufferPointer[1] = (uint8_t)((VAR_sendBufferCount >> 8) & 0xFF); // 
 */

	/*
	 *  DMAȥˡǡΥɥ쥹ȥΤ餻
	 */
	sil_wrw_mem((void*)(ATTR_uartBase+TOFF_PDC_TNPR), (uint_t)VAR_sendBufferPointer);
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR), (VAR_sendBufferCount));
	// DMAžǡϡǡ2byte¿
//    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR), (VAR_sendBufferCount + 2));
}

/*
 *  ߵ
 *  Хåե
 */
Inline void
uart_enable_send(CELLCB *p_cellcb)
{
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IER), US_TXBUFE);
}

/*
 *  ߶ػ
 *  Хåե
 */
Inline void
uart_disable_send(CELLCB *p_cellcb)
{
	sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IDR), US_TXBUFE);
}


/*
 *  ߵ
 *  ENDRX  Хåե1FULL
 */
Inline void
uart_enable_rcv(CELLCB *p_cellcb)
{
	if(cBluetooth_getStatus() == BT_STREAM){ // Bluetooth̿ΩƤʤOK
		sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IER), US_ENDRX);
	}
}

/*
 *  ߶ػ
 *  ENDRX  Хåե1FULL
 */
Inline void
uart_disable_rcv(CELLCB *p_cellcb)
{
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IDR), US_ENDRX);
}

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eSIOPort
 * entry port: eSIOPort
 * signature:  sSIOPort
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSIOPort_open
 * name:         eSIOPort_open
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_open
 * oneway:       false
 * #[</ENTRY_FUNC>]# */

/*
 *  ꥢI/OݡȤΥץ
 */
void
eSIOPort_open(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	bool_t opnflg;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	opnflg = VAR_openFlag;
	
	VAR_openFlag = true;

	if(!opnflg) {
		/* ػ */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), (US_RXDIS | US_TXDIS));
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_PTCR), (PDC_RXTDIS | PDC_TXTDIS));
		
		/*
		 *  DMAϢ쥸ν
		 */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR), 0);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), 0);
		
		/*
		 *  DMA˼ѥХåեꤹ
		 */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RPR), (uint32_t)VAR_receiveBuffer1);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR), ATTR_receiveBufferSize);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNPR), (uint32_t)VAR_receiveBuffer2);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), ATTR_receiveBufferSize);

		/*  */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), (US_RXEN | US_TXEN));
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_PTCR), (PDC_RXTEN | PDC_TXTEN));

		ena_int(INTNO_SIO);
	}

	uart_enable_rcv(p_cellcb); /* ߤĤ */
}

/* #[<ENTRY_FUNC>]# eSIOPort_close
 * name:         eSIOPort_close
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_close
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/* 
 *  ꥢI/OݡȤΥ
 */
void
eSIOPort_close(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	sil_wrw_mem((void *)(ATTR_uartBase + TOFF_US_CR), US_RSTRX|US_RSTTX|US_RXDIS|US_TXDIS);
	
	VAR_openFlag = false;

	dis_int(INTNO_SIO);
}

/* #[<ENTRY_FUNC>]# eSIOPort_putChar
 * name:         eSIOPort_putChar
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_putChar
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
eSIOPort_putChar(CELLIDX idx, char_t c)
{
	CELLCB	*p_cellcb;
	int_t	n;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	if(cBluetooth_getStatus() != BT_STREAM) { // bluetooth³ƤʤǤʤ
		return true; // ⤷ʤ
	}

	/*
	 *  ԲĤȤʤϼ1. or 2.ΩȤ
	 *  1. åȰ¸ΥХåե2ĤȤǤ
	 *  2. å¸ΥХåեǥƥȤƤФ줿
	 */
	if(VAR_UsedTargetbuffer || (VAR_UsedKernelbuffer && (senseContext() == false))){
		return false;
	}
	
	VAR_sendBufferPointer[VAR_sendBufferCount] = c; // Хåեʸ
	VAR_sendBufferCount++;                        // Хåեʸ򥤥󥯥

	if(c == '\n' || VAR_sendBufferCount >= ATTR_sendBufferSize) { // ʸξ or Хåեեξ
		
		if(uart_puts_ready(p_cellcb)) { // ǽɤå
			uart_puts(p_cellcb);        // DMAžϤ

		} else {                        // DMAž
			VAR_UsedTargetbuffer = true;
			//uart_enable_send(p_cellcb); // ߵ
			
//			cSendSemaphore_wait();      // ISRDMAžϤޤԤ

			return false;               // ¸ΥХåեˤϤ
		}
		
		rot_target_send_buf(p_cellcb);  // Хåեؤ
		VAR_sendBufferCount = 0U;        // Хåեʸꥻå
	}

	return true;
}

/* #[<ENTRY_FUNC>]# eSIOPort_getChar
 * name:         eSIOPort_getChar
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_getChar
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  ꥢI/OݡȤʸ
 */
int_t
eSIOPort_getChar(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	char_t	c;
	int_t	n;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

    if (uart_getready(p_cellcb)) {
		/* TEST */
#if 0
		display_clear(0);
		display_goto_xy(0,0);
		display_string("RPR:");
		display_int(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RPR)), 0);
		display_goto_xy(0,1);
		display_string("RNPR:");
		display_int(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RNPR)), 0);
		display_goto_xy(0,2);
		display_string("Ptr:");
		display_int(VAR_receiveBufferPointer, 0);
		display_goto_xy(0,3);
		display_string("1:");
		display_int(VAR_receiveBuffer1, 0);
		display_goto_xy(0,4);
		display_string("2:");
		display_int(VAR_receiveBuffer2, 0);
		display_goto_xy(0,5);
		display_string("Ptr[]:");
		display_int(VAR_receiveBufferPointer[0], 0);
		display_goto_xy(0,6);
		display_string("1[]:");
		display_int(VAR_receiveBuffer1[0], 0);
		display_goto_xy(0,7);
		display_string("2[]:");
		display_int(VAR_receiveBuffer2[0], 0);
		
		display_update();
#endif /* TEST */
	  return((int_t)(uint8_t) uart_getchar(p_cellcb));
    }

    return(false);
}

/* #[<ENTRY_FUNC>]# eSIOPort_enableCBR
 * name:         eSIOPort_enableCBR
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_enableCBR
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  ꥢI/OݡȤΥХåε
 */
void
eSIOPort_enableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_enable_send(p_cellcb);
		VAR_UsedKernelbuffer = true; // ¸ΥХåեʸ򤿤
		break;
	  case SIO_RDY_RCV:
		uart_enable_rcv(p_cellcb);
		break;
	}
}

/* #[<ENTRY_FUNC>]# eSIOPort_disableCBR
 * name:         eSIOPort_disableCBR
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_disableCBR
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
eSIOPort_disableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_disable_send(p_cellcb);
		VAR_UsedKernelbuffer = false; // ¸ΥХåեʸʤʤä
		break;
	  case SIO_RDY_RCV:
		uart_disable_rcv(p_cellcb);
		break;
	}
}

/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tSIOPortMindstormsNXT_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  SIOɥ饤Фν
 */
void
eInitialize_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	uint32_t dummy;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	
	/*
	 *  ꥢI/OݡȤν
	 */
	VAR_openFlag = false;
	
	/*
	 *  Хåեν
	 */
	VAR_sendBufferPointer = VAR_sendBuffer1;
	VAR_sendBufferCount = 0U;

	VAR_receiveBufferPointer = VAR_receiveBuffer1;
	VAR_receiveBufferCount = 0U;

	/*
	 *  UARTϢ쥸ν
	 */
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), US_RSTSTA);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), US_STTTO);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_RTOR), 1000);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_IDR), US_TIMEOUT);
	
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_MR), ((US_USMODE_HWHSH & ~US_SYNC) | US_CLKS_CLOCK | US_CHRL_8 | US_PAR_NO | US_NBSTOP_1 | US_OVER));
	
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_BRGR), ((CLOCK_RATE/8/BAUD_RATE) | (((CLOCK_RATE/8) - ((CLOCK_RATE/8/BAUD_RATE) * BAUD_RATE)) / ((BAUD_RATE + 4)/8)) << 16));

	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_PTCR), (PDC_RXTDIS | PDC_TXTDIS));

	dummy = sil_rew_mem((void *)(ATTR_uartBase+TOFF_US_RHR));
	dummy = sil_rew_mem((void *)(ATTR_uartBase+TOFF_US_CSR));
	
	/*
	 *  DMAϢ쥸ν
	 */
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR), 0);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), 0);
}

/* #[<ENTRY_PORT>]# eTerminate
 * entry port: eTerminate
 * signature:  sTerminateRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTerminate_main
 * name:         eTerminate_main
 * global_name:  tSIOPortMindstormsNXT_eTerminate_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  SIOɥ饤Фνλ
 */
void
eTerminate_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	/*
	 *  ץ󤵤Ƥ륷ꥢI/OݡȤΥ
	 */
	if (VAR_openFlag) {
		/*
		 *  饤֥¦ǽλԤ
		 */
		VAR_openFlag = false;
		/*
		 *  ꥢI/Oߤޥ롥
		 */
		dis_int(INTNO_SIO);
	}
}


/* #[<ENTRY_PORT>]# eiISR
 * entry port: eiISR
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiISR_main
 * name:         eiISR_main
 * global_name:  tSIOPortMindstormsNXT_eiISR_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  SIOγߥӥ롼
 *  mindstormsNXTǤbluetooth³ƤUARTΥݡȤ1
 *  ʤᡤ٥ϤɸϤˤơUART
 *  ݡȤͭƤ롥
 *  ٥ϤDMAžԤȡɸϤǤDMAžԤƱ
 *  ȡ٥ϤDMAž1ʬ٤ǽ롥
 *  㡧٥ϤDMAԤ
 *     ɸϤDMAԤ
 *     ISRɸϤDMAž
 *     ٥ϤǤʤɸϤͥ褷Ƽ¹ԤƤޤ
 */
void
eiISR_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	/* DMAˤХåե饷ꥢݡȤؤλȤ */
	if (uart_puts_ready(p_cellcb)) { // DMAžä
		if(VAR_UsedTargetbuffer){            // ¸ΥХåեʸ
			uart_puts(p_cellcb);           // ʸ
			rot_target_send_buf(p_cellcb); // Хåեؤ
			VAR_sendBufferCount = 0U;      // ݥ󥿤ν
			VAR_UsedTargetbuffer = false;
		} else {                           // ¸ΥХåեʸ
			ciSIOCBR_readySend();
		}
	}

	/* DMAǥꥢݡȤХåե1ʸȤ */
	if (uart_getready(p_cellcb)) {
		ciSIOCBR_readyReceive();
	}

}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
