/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: dbgu_serial.h 948 2008-04-14 08:34:27Z ertl-honda $
 */

/*
 * ꥢI/OǥХSIO˥ɥ饤СAT91SAM7Sѡ
 */

#ifndef TOPPERS_CHIP_SERIAL_H
#define TOPPERS_CHIP_SERIAL_H

#include "arm_gcc/nxt/at91sam7s.h"

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#define INHNO_SIO        INTNO_US1_PID /* ߥϥɥֹ */
#define INTNO_SIO        INTNO_US1_PID /* ֹ */
#define INTPRI_SIO       -2               /* ͥ */
#define INTATR_SIO       0U               /* ° */

/*
 *  ꥢI/Oݡȿ
 */
#define TNUM_SIOP		1		/* ݡȤ륷ꥢI/OݡȤο */

#define TARGET_SEND_MAX 128

#define TADR_US1_BASE 0xFFFC4000

#define US_ENDRX 0x0008
#define US_TXBUFE 0x0800
#define US_RXBUFF 0x01000

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  SIOɥ饤Фν
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  SIOγߥϥɥ
 */
extern void sio_isr(ID siopid);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char_t c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);

/*
 *  bluetooth³
 */
extern uint8_t ecrobot_get_bt_status(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CHIP_SERIAL_H */
