/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * ƤӸؿ #_TCPF_#
 * call port : cSimple  signature: sSimple context: task
 *   ER             cSimple_onewayPtr( const uint32_t* in );
 *   ER             cSimple_onewayArray( const uint32_t* in, int32_t len );
 *   ER             cSimple_onewayDoubleArray( const int32_t* in, int32_t len, const int32_t* in2, int32_t len2 );
 *   ER             cSimple_onewayString( const char_t* in, int32_t len );
 *   ER             cSimple_onewayStruct( const struct stA * a );
 *   ER             cSimple_onewayStruct2( const struct stA * a, int32_t len );
 *   void           cSimple_exit( );
 * allocator port for call port: eEnt func: giftToYou param: buf
 *   ER             eEnt_giftToYou_buf_alloc( int32_t size, void** p );
 *   ER             eEnt_giftToYou_buf_dealloc( const void* ptr );
 * allocator port for call port: eEnt func: returnGiftFromYou param: buf
 *   ER             eEnt_returnGiftFromYou_buf_alloc( int32_t size, void** p );
 *   ER             eEnt_returnGiftFromYou_buf_dealloc( const void* ptr );
 * allocator port for call port: eEnt func: onewayFunc param: buf
 *   ER             eEnt_onewayFunc_buf_alloc( int32_t size, void** p );
 *   ER             eEnt_onewayFunc_buf_dealloc( const void* ptr );
 *
 * #[</PREAMBLE>]# */

#include "tSample_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* ｪλ */
#define	E_ID	(-18)	/* IDֹ */
#endif


/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eEnt
 * entry port: eEnt
 * signature:  sSample
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eEnt_sayHello
 * name:         eEnt_sayHello
 * global_name:  tSample_eEnt_sayHello
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eEnt_sayHello(CELLIDX idx, int32_t times)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	printf( "Sample: " );
	while( times-- > 0 )
		printf( "hello " );
	printf( "\n" );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eEnt_howAreYou
 * name:         eEnt_howAreYou
 * global_name:  tSample_eEnt_howAreYou
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eEnt_howAreYou(CELLIDX idx, char_t* buf, int32_t len)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	printf( "tSample: buf addr: %08x, size: %d\n", buf, len );
	/* ˽Τ򵭽Ҥޤ */
	strncpy( buf, "Sample: I'm fine!", len );

	return(ercd);
}


/* #[<ENTRY_FUNC>]# eEnt_giftToYou
 * name:         eEnt_giftToYou
 * global_name:  tSample_eEnt_giftToYou
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eEnt_giftToYou(CELLIDX idx, char_t* buf, int32_t len)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	printf( "tSample: Gift: %s\n", buf );

	eEnt_giftToYou_buf_dealloc( buf );
	return(ercd);
}

/* #[<ENTRY_FUNC>]# eEnt_returnGiftFromYou
 * name:         eEnt_returnGiftFromYou
 * global_name:  tSample_eEnt_returnGiftFromYou
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eEnt_returnGiftFromYou(CELLIDX idx, int16_t** buf, int32_t* len)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	int16_t *allocbuf;

	int_t   i;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
#define GIFT_LEN 512
	eEnt_returnGiftFromYou_buf_alloc( GIFT_LEN * sizeof(int16_t), (void **)&allocbuf );
	for( i = 0; i < GIFT_LEN; i++ )
		allocbuf[i] = i;

	*buf = allocbuf;
	*len = GIFT_LEN;
	return(ercd);
}

/* #[<ENTRY_FUNC>]# eEnt_transferStruct
 * name:         eEnt_transferStruct
 * global_name:  tSample_eEnt_transferStruct
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eEnt_transferStruct(CELLIDX idx, const struct stA * a, int32_t len)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	int32_t i;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	printf( "transferStruct: len=%d\n", len );
	for( i = 0; i < len; i++ ){
		printf( "i=%d a=%d, b=%d\n", i, a[i].a, a[i].b );
	}

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eEnt_transferStruct2
 * name:         eEnt_transferStruct2
 * global_name:  tSample_eEnt_transferStruct2
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eEnt_transferStruct2(CELLIDX idx, struct stA  a)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eEnt_onewayFunc
 * name:         eEnt_onewayFunc
 * global_name:  tSample_eEnt_onewayFunc
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
ER
eEnt_onewayFunc(CELLIDX idx, char_t* buf, int32_t len)
{
	CELLCB	*p_cellcb;
	int     i;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		/* oneway ξ E_OK ֤ޤ */
		return(E_OK);
	}

	printf( "onewayFunc: len=%d\n", len );
	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	for( i = 0; i < len; i++ ){
		if( i % 8 == 0 )
			printf( "%d: ", i );
		printf( "%02X ", buf[i] );
		if( i % 8 == 7 )
			printf( "\n" );
	}
	eEnt_onewayFunc_buf_dealloc( buf );

	{
		int32_t  in, i;
#define BUF_LEN   8
#define BUF_LEN2  4
		int32_t  buf[BUF_LEN];
		int32_t  buf2[BUF_LEN2];

		in = 999;
		cSimple_onewayPtr( &in );

		for( i = 0; i < BUF_LEN; i++ )
			buf[i]= (i+1)*2;
		cSimple_onewayArray( buf, BUF_LEN );

		for( i = 0; i < BUF_LEN; i++ )
			buf[i]= (i+1)*2;
		for( i = 0; i < BUF_LEN2; i++ )
			buf2[i]= (i+2)*3;
		cSimple_onewayDoubleArray( buf, BUF_LEN, buf2, BUF_LEN2 );
	}

#define MESSAGE "Hello TECS !"
	cSimple_onewayString( MESSAGE, sizeof( MESSAGE ) );

	{
		struct stA stA;

		stA.a = 999;
		stA.b = 1001;
		cSimple_onewayStruct( &stA );
	}

	{
#define  LEN  5
		struct stA stA[LEN];
		int32_t  len = LEN;

		for( i = 0; i < LEN; i++ ){
			stA[i].a = 999  + i;
			stA[i].b = 2001 + i * 2;
		}
		cSimple_onewayStruct2( stA, len );
	}

	cSimple_exit( );
	printf( "tSample: onewayFunc: reach end!!!!\n" );

	/* oneway ξ E_OK ֤ޤ */
	return(E_OK);
}

/* #[<ENTRY_FUNC>]# eEnt_exit
 * name:         eEnt_exit
 * global_name:  tSample_eEnt_exit
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
void
eEnt_exit(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		/* 顼ɤ򤳤˵Ҥޤ */
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	pthread_exit(0);
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
