/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id:
 */

/*
 *  foCXhCoimindstormsNXTs̗pj
 */

#ifndef TARGET_DEVICE_H
#define TARGET_DEVICE_H

#include "arm_gcc/nxt/at91sam7s.h"

/*
 *  ݃nho^̂߂̒萔
 */
#define INHNO_MOTOR     INTNO_PIOA_PID  /* ݃nhԍ */
#define INTNO_MOTOR     INTNO_PIOA_PID  /* ݔԍ */
#define INTPRI_MOTOR    -4             /* ݗDx */
#define INTATR_MOTOR    TA_LOWLEVEL             /* ݑ */

#define INHNO_SPI     INTNO_SPI_PID  /* ݃nhԍ */
#define INTNO_SPI     INTNO_SPI_PID  /* ݔԍ */
#define INTPRI_SPI    -4             /* ݗDx */
#define INTATR_SPI    TA_LOWLEVEL             /* ݑ */

#define INHNO_SOUND     INTNO_SSC_PID  /* ݃nhԍ */
#define INTNO_SOUND     INTNO_SSC_PID  /* ݔԍ */
#define INTPRI_SOUND    -1             /* ݗDx */
#define INTATR_SOUND    TA_EDGE             /* ݑ */

#define INHNO_TWI     INTNO_TWI_PID  /* ݃nhԍ */
#define INTNO_TWI     INTNO_TWI_PID  /* ݔԍ */
#define INTPRI_TWI    -5             /* ݗDx */
#define INTATR_TWI    TA_LOWLEVEL             /* ݑ */

#define INHNO_UDP     INTNO_UDP_PID  /* ݃nhԍ */
#define INTNO_UDP     INTNO_UDP_PID  /* ݔԍ */
#define INTPRI_UDP    -1             /* ݗDx */
#define INTATR_UDP    TA_LOWLEVEL             /* ݑ */

#define INHNO_I2C INTNO_TC0_PID
#define INTNO_I2C INTNO_TC0_PID
#define INTPRI_I2C -4
#define INTATR_I2C TA_LOWLEVEL

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ݃nh
 */

extern void    nxt_motor_isr_C(void);
extern void    spi_isr_C(void);
extern void    sound_isr_C(void);
extern void    twi_isr_C(void);
extern void    udp_isr_C(void);

extern void    systick_isr_C(void);
extern void    systick_low_priority_C(void);
extern void    target_timer_handler(void);
extern void    i2c_timer_C(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TARGET_DEVICE_H */
